# H323Connection Class Reference

`#include <h323con.h>`

Inheritance diagram for H323Connection:

List of all members.

## Control Channel

enum | ControlProtocolErrors { e_MasterSlaveDetermination, e_CapabilityExchange, e_LogicalChannel, e_ModeRequest, e_RoundTripDelay }
virtual PBoolean | CreateOutgoingControlChannel (const H225_TransportAddress &h245Address)
virtual PBoolean | CreateIncomingControlChannel (H225_TransportAddress &h245Address)
virtual PBoolean | WriteControlPDU (const H323ControlPDU &pdu)
virtual PBoolean | StartControlNegotiations ()
virtual void | HandleControlChannel ()
virtual PBoolean | HandleControlData (PPER_Stream &strm)
virtual PBoolean | HandleControlPDU (const H323ControlPDU &pdu)
virtual PBoolean | OnUnknownControlPDU (const H323ControlPDU &pdu)
virtual PBoolean | OnH245Request (const H323ControlPDU &pdu)
virtual PBoolean | OnH245Response (const H323ControlPDU &pdu)
virtual PBoolean | OnH245Command (const H323ControlPDU &pdu)
virtual PBoolean | OnH245Indication (const H323ControlPDU &pdu)
virtual PBoolean | OnH245_SendTerminalCapabilitySet (const H245_SendTerminalCapabilitySet &pdu)
virtual PBoolean | OnH245_FlowControlCommand (const H245_FlowControlCommand &pdu)
virtual PBoolean | OnH245_MiscellaneousCommand (const H245_MiscellaneousCommand &pdu)
virtual PBoolean | OnH245_MiscellaneousIndication (const H245_MiscellaneousIndication &pdu)
virtual PBoolean | OnH245_JitterIndication (const H245_JitterIndication &pdu)
virtual PBoolean | OnControlProtocolError (ControlProtocolErrors errorSource, const void *errorData=NULL)
virtual void | OnSendCapabilitySet (H245_TerminalCapabilitySet &pdu)
virtual PBoolean | OnReceivedCapabilitySet (const H323Capabilities &remoteCaps, const H245_MultiplexCapability *muxCap, H245_TerminalCapabilitySetReject &reject)
virtual bool | SendCapabilitySet (PBoolean empty)
virtual bool | IsSendingCapabilitySet ()
virtual void | OnSetLocalCapabilities ()
PBoolean | IsH245Master () const
void | StartRoundTripDelay ()
PTimeInterval | GetRoundTripDelay () const

## Public Member Functions

virtual PBoolean | OnSendFeatureSet (unsigned, H225_FeatureSet &) const
virtual void | OnReceiveFeatureSet (unsigned, const H225_FeatureSet &) const
virtual PBoolean | OnOpenIncomingMediaChannels ()
virtual void | OnMediaCommand (OpalMediaCommand &note, INT extra)
Overrides from OpalConnection
virtual bool | IsNetworkConnection () const
virtual PString | GetPrefixName () const
virtual PBoolean | SetUpConnection ()
virtual PBoolean | SetAlerting (const PString &calleeName, PBoolean withMedia)
virtual PBoolean | SetConnected ()
virtual PBoolean | SetProgressed ()
virtual void | OnEstablished ()
virtual void | OnReleased ()
virtual PString | GetDestinationAddress ()
virtual OpalMediaFormatList | GetMediaFormats () const
virtual OpalMediaStreamPtr | OpenMediaStream (const OpalMediaFormat &mediaFormat, unsigned sessionID, bool isSource)
virtual bool | CloseMediaStream (OpalMediaStream &stream)
virtual PBoolean | GetMediaInformation (unsigned sessionID, MediaInformation &info) const
Backward compatibility functions
virtual void | OnCleared ()
PBoolean | IsEstablished () const
virtual void | CleanUpOnCallEnd ()
Signalling Channel
void | AttachSignalChannel (const PString &token, H323Transport *channel, PBoolean answeringCall)
PBoolean | WriteSignalPDU (H323SignalPDU &pdu)
virtual void | HandleSignallingChannel ()
virtual PBoolean | HandleSignalPDU (H323SignalPDU &pdu)
virtual void | HandleTunnelPDU (H323SignalPDU *txPDU)
virtual PBoolean | OnReceivedSignalSetup (const H323SignalPDU &pdu)
virtual PBoolean | OnReceivedSignalSetupAck (const H323SignalPDU &pdu)
virtual PBoolean | OnReceivedSignalInformation (const H323SignalPDU &pdu)
virtual PBoolean | OnReceivedCallProceeding (const H323SignalPDU &pdu)
virtual PBoolean | OnReceivedProgress (const H323SignalPDU &pdu)
virtual PBoolean | OnReceivedAlerting (const H323SignalPDU &pdu)
virtual PBoolean | OnReceivedSignalConnect (const H323SignalPDU &pdu)
virtual PBoolean | OnReceivedFacility (const H323SignalPDU &pdu)
virtual PBoolean | OnReceivedSignalNotify (const H323SignalPDU &pdu)
virtual PBoolean | OnReceivedSignalStatus (const H323SignalPDU &pdu)
virtual PBoolean | OnReceivedStatusEnquiry (const H323SignalPDU &pdu)
virtual void | OnReceivedReleaseComplete (const H323SignalPDU &pdu)
virtual PBoolean | OnUnknownSignalPDU (const H323SignalPDU &pdu)
virtual void | OnSendARQ (H225_AdmissionRequest &arq)
virtual void | OnReceivedACF (const H225_AdmissionConfirm &acf)
virtual void | OnReceivedARJ (const H225_AdmissionReject &arj)
virtual void | OnSendIRR (H225_InfoRequestResponse &irr) const
virtual void | OnSendDRQ (H225_DisengageRequest &drq) const
virtual PBoolean | OnIncomingCall (const H323SignalPDU &setupPDU, H323SignalPDU &alertingPDU)
virtual PBoolean | ForwardCall (const PString &forwardParty)
virtual bool | TransferConnection (const PString &remoteParty)
virtual bool | HoldConnection ()
virtual bool | RetrieveConnection ()
virtual PBoolean | IsConnectionOnHold ()
virtual AnswerCallResponse | OnAnswerCall (const PString &callerName, const H323SignalPDU &setupPDU, H323SignalPDU &connectPDU, H323SignalPDU &progressPDU)
virtual AnswerCallResponse | OnAnswerCall (const PString &callerName)
void | AnsweringCall (AnswerCallResponse response)
virtual CallEndReason | SendSignalSetup (const PString &alias, const H323TransportAddress &address)
virtual PBoolean | OnSendSignalSetup (H323SignalPDU &setupPDU)
virtual PBoolean | OnSendCallProceeding (H323SignalPDU &callProceedingPDU)
virtual PBoolean | OnSendReleaseComplete (H323SignalPDU &releaseCompletePDU)
virtual PBoolean | OnAlerting (const H323SignalPDU &alertingPDU, const PString &user)
virtual PBoolean | OnInsufficientDigits ()
virtual void | SendMoreDigits (const PString &digits)
virtual PBoolean | OnOutgoingCall (const H323SignalPDU &connectPDU)
virtual PBoolean | SendFastStartAcknowledge (H225_ArrayOf_PASN_OctetString &array)
virtual PBoolean | HandleFastStartAcknowledge (const H225_ArrayOf_PASN_OctetString &array)
Logical Channel Management
virtual void | OnSelectLogicalChannels ()
virtual void | SelectDefaultLogicalChannel (const OpalMediaType &mediaType, unsigned sessionID)
virtual void | SelectFastStartChannels (unsigned sessionID, PBoolean transmitter, PBoolean receiver)
virtual void | StartFastStartChannel (unsigned sessionID, H323Channel::Directions direction)
virtual PBoolean | OpenLogicalChannel (const H323Capability &capability, unsigned sessionID, H323Channel::Directions dir)
virtual void | SendFlowControlCommand (unsigned channelNumber, unsigned newBitRate)
virtual PBoolean | OnOpenLogicalChannel (const H245_OpenLogicalChannel &openPDU, H245_OpenLogicalChannelAck &ackPDU, unsigned &errorCode)
virtual PBoolean | OnConflictingLogicalChannel (H323Channel &channel)
virtual H323Channel * | CreateLogicalChannel (const H245_OpenLogicalChannel &open, PBoolean startingFast, unsigned &errorCode)
virtual H323Channel * | CreateRealTimeLogicalChannel (const H323Capability &capability, H323Channel::Directions dir, unsigned sessionID, const H245_H2250LogicalChannelParameters *param, RTP_QOS *rtpqos=NULL)
virtual PBoolean | OnCreateLogicalChannel (const H323Capability &capability, H323Channel::Directions dir, unsigned &errorCode)
virtual PBoolean | OnStartLogicalChannel (H323Channel &channel)
virtual void | CloseLogicalChannel (unsigned number, PBoolean fromRemote)
virtual void | CloseLogicalChannelNumber (const H323ChannelNumber &number)
virtual void | CloseAllLogicalChannels (PBoolean fromRemote)
virtual void | OnClosedLogicalChannel (const H323Channel &channel)
virtual PBoolean | OnClosingLogicalChannel (H323Channel &channel)
virtual void | OnLogicalChannelFlowControl (H323Channel *channel, long bitRateRestriction)
virtual void | OnLogicalChannelJitter (H323Channel *channel, DWORD jitter, int skippedFrameCount, int additionalBuffer)
H323Channel * | GetLogicalChannel (unsigned number, PBoolean fromRemote) const
H323Channel * | FindChannel (unsigned sessionId, PBoolean fromRemote) const
Bandwidth Management
virtual PBoolean | SetBandwidthAvailable (unsigned newBandwidth, PBoolean force=PFalse)
virtual unsigned | GetBandwidthUsed () const
Indications
virtual SendUserInputModes | GetRealSendUserInputMode () const
virtual PBoolean | SendUserInputString (const PString &value)
virtual PBoolean | SendUserInputTone (char tone, unsigned duration=0)
virtual PBoolean | SendUserInputIndicationQ931 (const PString &value)
virtual PBoolean | SendUserInputIndicationString (const PString &value)
virtual PBoolean | SendUserInputIndicationTone (char tone, unsigned duration=0, unsigned logicalChannel=0, unsigned rtpTimestamp=0)
virtual PBoolean | SendUserInputIndication (const H245_UserInputIndication &pdu)
virtual void | OnUserInputIndication (const H245_UserInputIndication &pdu)
RTP Session Management
virtual H323_RTP_Session * | GetSessionCallbacks (unsigned sessionID) const
virtual RTP_Session * | UseSession (const OpalTransport &transport, unsigned sessionID, const OpalMediaType &mediatype, RTP_QOS *rtpqos=NULL)
virtual void | ReleaseSession (unsigned sessionID)
virtual void | OnRTPStatistics (const RTP_Session &session) const
virtual PString | GetSessionCodecNames (unsigned sessionID) const
Request Mode Changes
virtual PBoolean | RequestModeChange (const PString &newModes)
virtual PBoolean | RequestModeChange (const H245_ArrayOf_ModeDescription &newModes)
virtual PBoolean | OnRequestModeChange (const H245_RequestMode &pdu, H245_RequestModeAck &ack, H245_RequestModeReject &reject, PINDEX &selectedMode)
virtual void | OnModeChanged (const H245_ModeDescription &newMode)
virtual void | OnAcceptModeChange (const H245_RequestModeAck &pdu)
virtual void | OnRefusedModeChange (const H245_RequestModeReject *pdu)
Other services
virtual PBoolean | RequestModeChangeT38 (const char *capabilityNames="T.38\nT38FaxUDP")
virtual PBoolean | GetAdmissionRequestAuthentication (const H225_AdmissionRequest &arq, H235Authenticators &authenticators)
Member variable access
H323EndPoint & | GetEndPoint () const
PBoolean | HadAnsweredCall () const
PBoolean | IsGatekeeperRouted () const
unsigned | GetDistinctiveRing () const
void | SetDistinctiveRing (unsigned pattern)
const PString & | GetCallToken () const
unsigned | GetCallReference () const
const OpalGloballyUniqueID & | GetCallIdentifier () const
const OpalGloballyUniqueID & | GetConferenceIdentifier () const
void | SetLocalPartyName (const PString &name)
const PStringList & | GetLocalAliasNames () const
virtual void | SetRemotePartyInfo (const H323SignalPDU &pdu)
void | SetRemoteApplication (const H225_EndpointType &pdu)
PString | GetRemotePartyURL () const
const H323Capabilities & | GetLocalCapabilities () const
const H323Capabilities & | GetRemoteCapabilities () const
unsigned | GetRemoteMaxAudioDelayJitter () const
const H323Transport * | GetSignallingChannel () const
unsigned | GetSignallingVersion () const
const H323Transport & | GetControlChannel () const
OpalTransport & | GetTransport () const
unsigned | GetControlVersion () const
unsigned | GetUUIEsRequested () const
void | SetUUIEsRequested (unsigned mask)
const PString | GetGkAccessTokenOID () const
void | SetGkAccessTokenOID (const PString &oid)
const PBYTEArray & | GetGkAccessTokenData () const
void | SetDestExtraCallInfo (const PString &info)
void | SetRemotCallWaiting (const unsigned value)
int | GetRemoteCallWaiting () const
void | SetEnforcedDurationLimit (unsigned seconds)

## Protected Types

enum | ConnectionStates { NoConnectionActive, AwaitingGatekeeperAdmission, AwaitingTransportConnect, AwaitingSignalConnect, AwaitingLocalAnswer, HasExecutedSignalConnect, EstablishedConnection, ShuttingDownConnection, NumConnectionStates }
enum | FastStartStates { FastStartDisabled, FastStartInitiate, FastStartResponse, FastStartAcknowledged, NumFastStartStates }

## Protected Member Functions

virtual void | InternalEstablishedConnectionCheck ()
PBoolean | InternalEndSessionCheck (PPER_Stream &strm)
void | SetRemoteVersions (const H225_ProtocolIdentifier &id)
void | MonitorCallStatus ()
| PDECLARE_NOTIFIER (PThread, H323Connection, StartOutgoing)
| PDECLARE_NOTIFIER (PThread, H323Connection, NewOutgoingControlChannel)
| PDECLARE_NOTIFIER (PThread, H323Connection, NewIncomingControlChannel)

## Protected Attributes

H323EndPoint & | endpoint
int | remoteCallWaiting
PBoolean | gatekeeperRouted
unsigned | distinctiveRing
unsigned | callReference
OpalGloballyUniqueID | conferenceIdentifier
PString | localDestinationAddress
PStringList | localAliasNames
H323Capabilities | localCapabilities
PString | destExtraCallInfo
H323Capabilities | remoteCapabilities
unsigned | remoteMaxAudioDelayJitter
PTimer | roundTripDelayTimer
WORD | maxAudioDelayJitter
unsigned | uuiesRequested
PString | gkAccessTokenOID
PBYTEArray | gkAccessTokenData
PBoolean | addAccessTokenToSetup
PBoolean | alertDone
H323Transport * | signallingChannel
H323Transport * | controlChannel
OpalListener * | controlListener
PBoolean | h245Tunneling
H323SignalPDU * | h245TunnelRxPDU
H323SignalPDU * | h245TunnelTxPDU
H323SignalPDU * | setupPDU
H323SignalPDU * | alertingPDU
H323SignalPDU * | connectPDU
H323SignalPDU * | progressPDU
enum H323Connection::ConnectionStates | connectionState
unsigned | h225version
unsigned | h245version
PBoolean | h245versionSet
PBoolean | doH245inSETUP
PBoolean | lastPDUWasH245inSETUP
PBoolean | mustSendDRQ
PBoolean | mediaWaitForConnect
PBoolean | transmitterSidePaused
bool | remoteTransmitPaused
PBoolean | earlyStart
PString | t38ModeChangeCapabilities
PSyncPoint | digitsWaitFlag
PBoolean | endSessionNeeded
PSyncPoint | endSessionReceived
PTimer | enforcedDurationLimit
PChannel * | holdMediaChannel
PBoolean | isConsultationTransfer
PBoolean | isCallIntrusion
unsigned | callIntrusionProtectionLevel
FastStartStates | fastStartState
H323LogicalChannelList | fastStartChannels
OpalMediaStreamPtr | fastStartMediaStream
H245NegMasterSlaveDetermination * | masterSlaveDeterminationProcedure
H245NegTerminalCapabilitySet * | capabilityExchangeProcedure
H245NegLogicalChannels * | logicalChannels
H245NegRequestMode * | requestModeProcedure
H245NegRoundTripDelay * | roundTripDelayProcedure

## Detailed Description

This class represents a particular H323 connection between two endpoints. There are at least two threads in use, this one to look after the signalling channel, an another to look after the control channel. There would then be additional threads created for each data channel created by the control channel protocol thread.

## Member Enumeration Documentation

enum H323Connection::ControlProtocolErrors

Error discriminator for the OnControlProtocolError() function.

Enumerator:

  e_MasterSlaveDetermination |
  e_CapabilityExchange |
  e_LogicalChannel |
  e_ModeRequest |
  e_RoundTripDelay |

enum H323Connection::ConnectionStates `[protected]`

Enumerator:

  NoConnectionActive |
  AwaitingGatekeeperAdmission |
  AwaitingTransportConnect |
  AwaitingSignalConnect |
  AwaitingLocalAnswer |
  HasExecutedSignalConnect |
  EstablishedConnection |
  ShuttingDownConnection |
  NumConnectionStates |

enum H323Connection::FastStartStates `[protected]`

Enumerator:

  FastStartDisabled |
  FastStartInitiate |
  FastStartResponse |
  FastStartAcknowledged |
  NumFastStartStates |

## Constructor & Destructor Documentation

H323Connection::H323Connection | ( | OpalCall & | call,
|  | H323EndPoint & | endpoint,
|  | const PString & | token,
|  | const PString & | alias,
|  | const H323TransportAddress & | address,
|  | unsigned | options = `0`,
|  | OpalConnection::StringOptions * | stringOptions = `NULL` |
| ) |  |  |

Create a new connection.

Parameters:

  call | Call object connection belongs to
  endpoint | H323 End Point object
  token | Token for new connection
  alias | Alias for outgoing call
  address | Address for outgoing call
  options | Connection option bits
  stringOptions | complex string options

H323Connection::~H323Connection | ( |  | ) |

Destroy the connection

H323Connection::H323Connection | ( | OpalCall & | call,
|  | H323EndPoint & | endpoint,
|  | const PString & | token,
|  | const PString & | alias,
|  | const H323TransportAddress & | address,
|  | unsigned | options = `0`,
|  | OpalConnection::StringOptions * | stringOptions = `NULL` |
| ) |  |  |

Create a new connection.

Parameters:

  call | Call object connection belongs to
  endpoint | H323 End Point object
  token | Token for new connection
  alias | Alias for outgoing call
  address | Address for outgoing call
  options | Connection option bits
  stringOptions | complex string options

H323Connection::~H323Connection | ( |  | ) |

Destroy the connection

## Member Function Documentation

virtual bool H323Connection::IsNetworkConnection | ( |  | ) | const`[inline, virtual]`

Get indication of connection being to a "network". This indicates the if the connection may be regarded as a "network" connection. The distinction is about if there is a concept of a "remote" party being connected to and is best described by example: sip, h323, iax and pstn are all "network" connections as they connect to something "remote". While pc, pots and ivr are not as the entity being connected to is intrinsically local.

Implements OpalConnection.

virtual PString H323Connection::GetPrefixName | ( |  | ) | const`[virtual]`

Get this connections protocol prefix for URLs.

Reimplemented from OpalConnection.

virtual PBoolean H323Connection::SetUpConnection | ( |  | ) | `[virtual]`

Start an outgoing connection. This function will initiate the connection to the remote entity, for example in H.323 it sends a SETUP, in SIP it sends an INVITE etc.

The default behaviour is to send SETUP packet.

Implements OpalConnection.

virtual PBoolean H323Connection::SetAlerting | ( | const PString & | calleeName,
|  | PBoolean | withMedia |
| ) |  |  | `[virtual]`

Indicate to remote endpoint an alert is in progress. If this is an incoming connection and it is in the Alerting phase, then this function is used to indicate to that endpoint that an alert is in progress. This is usually due to another connection which is in the call (the B party) has received an OnAlerting() indicating that its remote endpoint is "ringing".

The default behaviour sends an ALERTING pdu.

Parameters:

  calleeName | Name of endpoint being alerted.
  withMedia | Open media with alerting

Implements OpalConnection.

virtual PBoolean H323Connection::SetConnected | ( |  | ) | `[virtual]`

Indicate to remote endpoint we are connected.

The default behaviour sends a CONNECT pdu.

Reimplemented from OpalConnection.

virtual PBoolean H323Connection::SetProgressed | ( |  | ) | `[virtual]`

Indicate to remote endpoint we are sending a progress.

The default behaviour sends a PROGRESS pdu.

virtual void H323Connection::OnEstablished | ( |  | ) | `[virtual]`

Called when a connection is established. This indicates that a connection to an endpoint was established. This usually occurs after OnConnected() and indicates that the connection is both connected and has media flowing.

Default behaviour is to call H323EndPoint::OnConnectionEstablished

Reimplemented from OpalConnection.

virtual void H323Connection::OnReleased | ( |  | ) | `[virtual]`

Clean up the termination of the connection. This function can do any internal cleaning up and waiting on background threads that may be using the connection object.

Note that there is not a one to one relationship with the OnEstablishedConnection() function. This function may be called without that function being called. For example if SetUpConnection() was used but the call never completed.

Classes that override this function should make sure they call the ancestor version for correct operation.

An application will not typically call this function as it is used by the OpalManager during a release of the connection.

The default behaviour calls CleanUpOnCallEnd() then calls the ancestor.

Reimplemented from OpalConnection.

virtual PString H323Connection::GetDestinationAddress | ( |  | ) | `[virtual]`

Get the destination address of an incoming connection. This will, for example, collect a phone number from a POTS line, or get the fields from the H.225 SETUP pdu in a H.323 connection.

Reimplemented from OpalConnection.

virtual OpalMediaFormatList H323Connection::GetMediaFormats | ( |  | ) | const`[virtual]`

Get the data formats this connection is capable of operating. This provides a list of media data format names that an OpalMediaStream may be created in within this connection.

The default behaviour returns media data format names contained in the remote capability table.

Reimplemented from OpalConnection.

virtual OpalMediaStreamPtr H323Connection::OpenMediaStream | ( | const OpalMediaFormat & | mediaFormat,
|  | unsigned | sessionID,
|  | bool | isSource |
| ) |  |  | `[virtual]`

Open source or sink media stream for session.

Parameters:

  mediaFormat | Media format to open
  sessionID | Session to start stream on
  isSource | Stream is a source/sink

Reimplemented from OpalConnection.

virtual bool H323Connection::CloseMediaStream | ( | OpalMediaStream & | stream | ) | `[virtual]`

Request close of a specific media stream. Note that this is usually asymchronous, the OnClosedMediaStream() function is called when the stream is really closed.

Parameters:

  stream | Stream to close

Reimplemented from OpalConnection.

virtual PBoolean H323Connection::GetMediaInformation | ( | unsigned | sessionID,
|  | MediaInformation & | info |
| ) |  |  | const`[virtual]`

Get information on the media channel for the connection. The default behaviour returns PTrue and fills the info structure if there is a media channel active for the sessionID.

Parameters:

  sessionID | Session ID for media channel
  info | Information on media channel

virtual void H323Connection::OnCleared | ( |  | ) | `[virtual]`

Called when a connection is cleared, just after CleanUpOnCallEnd() Default behaviour is to call H323Connection::OnConnectionCleared

PBoolean H323Connection::IsEstablished | ( |  | ) | const`[inline]`

Determine if the call has been established. This can be used in combination with the GetCallEndReason() function to determine the three main phases of a call, call setup, call established and call cleared.

virtual void H323Connection::CleanUpOnCallEnd | ( |  | ) | `[virtual]`

Clean up the call clearance of the connection. This function will do any internal cleaning up and waiting on background threads that may be using the connection object. After this returns it is then safe to delete the object.

An application will not typically use this function as it is used by the H323EndPoint during a clear call.

void H323Connection::AttachSignalChannel | ( | const PString & | token,
|  | H323Transport * | channel,
|  | PBoolean | answeringCall |
| ) |  |  |

Attach a transport to this connection as the signalling channel.

Parameters:

  token | New token to use to identify connection
  channel | Transport for the PDU's
  answeringCall | Flag for if incoming/outgoing call.

PBoolean H323Connection::WriteSignalPDU | ( | H323SignalPDU & | pdu | ) |

Write a PDU to the signalling channel.

Parameters:

  pdu | PDU to write.

virtual void H323Connection::HandleSignallingChannel | ( |  | ) | `[virtual]`

Handle reading PDU's from the signalling channel. This is an internal function and is unlikely to be used by applications.

virtual PBoolean H323Connection::HandleSignalPDU | ( | H323SignalPDU & | pdu | ) | `[virtual]`

Handle PDU from the signalling channel. This is an internal function and is unlikely to be used by applications.

Parameters:

  pdu | PDU to handle.

virtual void H323Connection::HandleTunnelPDU | ( | H323SignalPDU * | txPDU | ) | `[virtual]`

Handle Control PDU tunnelled in the signalling channel. This is an internal function and is unlikely to be used by applications.

Parameters:

  txPDU | PDU tunnel response into.

virtual PBoolean H323Connection::OnReceivedSignalSetup | ( | const H323SignalPDU & | pdu | ) | `[virtual]`

Handle an incoming Q931 setup PDU. The default behaviour is to do the handshaking operation calling a few virtuals at certain moments in the sequence.

If PFalse is returned the connection is aborted and a Release Complete PDU is sent.

Parameters:

  pdu | Received setup PDU

virtual PBoolean H323Connection::OnReceivedSignalSetupAck | ( | const H323SignalPDU & | pdu | ) | `[virtual]`

Handle an incoming Q931 setup acknowledge PDU. If PFalse is returned the connection is aborted and a Release Complete PDU is sent.

The default behaviour does nothing.

Parameters:

  pdu | Received setup PDU

virtual PBoolean H323Connection::OnReceivedSignalInformation | ( | const H323SignalPDU & | pdu | ) | `[virtual]`

Handle an incoming Q931 information PDU. If PFalse is returned the connection is aborted and a Release Complete PDU is sent.

The default behaviour does nothing.

Parameters:

  pdu | Received setup PDU

virtual PBoolean H323Connection::OnReceivedCallProceeding | ( | const H323SignalPDU & | pdu | ) | `[virtual]`

Handle an incoming Q931 call proceeding PDU. If PFalse is returned the connection is aborted and a Release Complete PDU is sent.

The default behaviour checks for hH245Address field and if present starts the separate H245 channel, if successful or not present it returns PTrue.

Parameters:

  pdu | Received call proceeding PDU

virtual PBoolean H323Connection::OnReceivedProgress | ( | const H323SignalPDU & | pdu | ) | `[virtual]`

Handle an incoming Q931 progress PDU. If PFalse is returned the connection is aborted and a Release Complete PDU is sent.

The default behaviour checks for hH245Address field and if present starts the separate H245 channel, if successful or not present it returns PTrue.

Parameters:

  pdu | Received call proceeding PDU

virtual PBoolean H323Connection::OnReceivedAlerting | ( | const H323SignalPDU & | pdu | ) | `[virtual]`

Handle an incoming Q931 alerting PDU. If PFalse is returned the connection is aborted and a Release Complete PDU is sent.

The default behaviour obtains the display name and calls OnAlerting().

Parameters:

  pdu | Received connect PDU

virtual PBoolean H323Connection::OnReceivedSignalConnect | ( | const H323SignalPDU & | pdu | ) | `[virtual]`

Handle an incoming Q931 connect PDU. If PFalse is returned the connection is aborted and a Release Complete PDU is sent.

The default behaviour checks for hH245Address field and if present starts the separate H245 channel, if successful it returns PTrue. If not present and there is no H245Tunneling then it returns PFalse.

Parameters:

  pdu | Received connect PDU

virtual PBoolean H323Connection::OnReceivedFacility | ( | const H323SignalPDU & | pdu | ) | `[virtual]`

Handle an incoming Q931 facility PDU. If PFalse is returned the connection is aborted and a Release Complete PDU is sent.

The default behaviour checks for hH245Address field and if present starts the separate H245 channel, if successful or not present it returns PTrue.

Parameters:

  pdu | Received connect PDU

virtual PBoolean H323Connection::OnReceivedSignalNotify | ( | const H323SignalPDU & | pdu | ) | `[virtual]`

Handle an incoming Q931 Notify PDU. If PFalse is returned the connection is aborted and a Release Complete PDU is sent.

The default behaviour simply returns PTrue.

Parameters:

  pdu | Received connect PDU

virtual PBoolean H323Connection::OnReceivedSignalStatus | ( | const H323SignalPDU & | pdu | ) | `[virtual]`

Handle an incoming Q931 Status PDU. If PFalse is returned the connection is aborted and a Release Complete PDU is sent.

The default behaviour simply returns PTrue.

Parameters:

  pdu | Received connect PDU

virtual PBoolean H323Connection::OnReceivedStatusEnquiry | ( | const H323SignalPDU & | pdu | ) | `[virtual]`

Handle an incoming Q931 Status Enquiry PDU. If PFalse is returned the connection is aborted and a Release Complete PDU is sent.

The default behaviour sends a Q931 Status PDU back.

Parameters:

  pdu | Received connect PDU

virtual void H323Connection::OnReceivedReleaseComplete | ( | const H323SignalPDU & | pdu | ) | `[virtual]`

Handle an incoming Q931 Release Complete PDU. The default behaviour calls Clear() using reason code based on the Release Complete Cause field and the current connection state.

Parameters:

  pdu | Received connect PDU

virtual PBoolean H323Connection::OnUnknownSignalPDU | ( | const H323SignalPDU & | pdu | ) | `[virtual]`

This function is called from the HandleSignallingChannel() function for unhandled PDU types.

If PFalse is returned the connection is aborted and a Release Complete PDU is sent. The default behaviour returns PTrue.

Parameters:

  pdu | Received PDU

virtual void H323Connection::OnSendARQ | ( | H225_AdmissionRequest & | arq | ) | `[virtual]`

called when an ARQ needs to be sent to a gatekeeper. This allows the connection to change or check fields in the ARQ before it is sent.

By default, this calls the matching function on the endpoint

virtual void H323Connection::OnReceivedACF | ( | const H225_AdmissionConfirm & | acf | ) | `[virtual]`

called when an ACF is received from a gatekeeper.

By default, this calls the matching function on the endpoint

virtual void H323Connection::OnReceivedARJ | ( | const H225_AdmissionReject & | arj | ) | `[virtual]`

called when an ARJ is received from a gatekeeper.

By default, this calls the matching function on the endpoint

virtual void H323Connection::OnSendIRR | ( | H225_InfoRequestResponse & | irr | ) | const`[virtual]`

called when an IRR needs to be sent to a gatekeeper. This allows the connection to change or check fields in the IRR before it is sent.

By default, this does nothing

virtual void H323Connection::OnSendDRQ | ( | H225_DisengageRequest & | drq | ) | const`[virtual]`

called when an DRQ needs to be sent to a gatekeeper. This allows the connection to change or check fields in the DRQ before it is sent.

By default, this does nothing

virtual PBoolean H323Connection::OnIncomingCall | ( | const H323SignalPDU & | setupPDU,
|  | H323SignalPDU & | alertingPDU |
| ) |  |  | `[virtual]`

Call back for incoming call. This function is called from the OnReceivedSignalSetup() function before it sends the Alerting PDU. It gives an opportunity for an application to alter the reply before transmission to the other endpoint.

If PFalse is returned the connection is aborted and a Release Complete PDU is sent.

The default behaviour calls the endpoint function of the same name.

Parameters:

  setupPDU | Received setup PDU
  alertingPDU | Alerting PDU to send

virtual PBoolean H323Connection::ForwardCall | ( | const PString & | forwardParty | ) | `[virtual]`

Forward incoming call to specified address. This would typically be called from within the OnIncomingCall() function when an application wishes to redirct an unwanted incoming call.

The return value is PTrue if the call is to be forwarded, PFalse otherwise. Note that if the call is forwarded the current connection is cleared with the ended call code of EndedByCallForwarded.

Parameters:

  forwardParty | Party to forward call to.

Reimplemented from OpalConnection.

virtual bool H323Connection::TransferConnection | ( | const PString & | remoteParty | ) | `[virtual]`

Initiate the transfer of an existing call (connection) to a new remote party.

If remoteParty is a valid call token, then the remote party is transferred to that party (consultation transfer) and both calls are cleared.

Parameters:

  remoteParty | Remote party to transfer the existing call to

Reimplemented from OpalConnection.

virtual bool H323Connection::HoldConnection | ( |  | ) | `[virtual]`

Put the current connection on hold, suspending all media streams. Simply calls HoldCall() which is kept for backward compatibility.

Reimplemented from OpalConnection.

virtual bool H323Connection::RetrieveConnection | ( |  | ) | `[virtual]`

Retrieve the current connection from hold, activating all media streams. Simply calls RetrieveCall() which is kept for backward compatibility.

Reimplemented from OpalConnection.

virtual PBoolean H323Connection::IsConnectionOnHold | ( |  | ) | `[virtual]`

Return PTrue if the current connection is on hold. Simply calls IsCallOnHold() which is kept for backward compatibility.

Reimplemented from OpalConnection.

virtual AnswerCallResponse H323Connection::OnAnswerCall | ( | const PString & | callerName,
|  | const H323SignalPDU & | setupPDU,
|  | H323SignalPDU & | connectPDU,
|  | H323SignalPDU & | progressPDU |
| ) |  |  | `[virtual]`

Call back for answering an incoming call. This function is used for an application to control the answering of incoming calls. It is usually used to indicate the immediate action to be taken in answering the call.

It is called from the OnReceivedSignalSetup() function before it sends the Alerting or Connect PDUs. It also gives an opportunity for an application to alter the Connect PDU reply before transmission to the remote endpoint.

If AnswerCallNow is returned then the H.323 protocol proceeds with the connection. If AnswerCallDenied is returned the connection is aborted and a Release Complete PDU is sent. If AnswerCallPending is returned then the Alerting PDU is sent and the protocol negotiations are paused until the AnsweringCall() function is called. Finally, if AnswerCallDeferred is returned then no Alerting PDU is sent, but the system still waits as in the AnswerCallPending response.

Note this function should not block for any length of time. If the decision to answer the call may take some time eg waiting for a user to pick up the phone, then AnswerCallPending or AnswerCallDeferred should be returned.

The default behaviour calls the endpoint function of the same name which in turn will return AnswerCallNow.

Parameters:

  callerName | Name of caller
  setupPDU | Received setup PDU
  connectPDU | Connect PDU to send.
  progressPDU | Progress PDU to send.

virtual AnswerCallResponse H323Connection::OnAnswerCall | ( | const PString & | callerName | ) | `[virtual]`

Call back for answering an incoming call. This function is called after the connection has been acknowledged but before the connection is established

This gives the application time to wait for some event before signalling to the endpoint that the connection is to proceed. For example the user pressing an "Answer call" button.

If AnswerCallDenied is returned the connection is aborted and the connetion specific end call PDU is sent. If AnswerCallNow is returned then the connection proceeding, Finally if AnswerCallPending is returned then the protocol negotiations are paused until the AnsweringCall() function is called.

The default behaviour calls the endpoint function of the same name.

Parameters:

  callerName | Name of caller

Reimplemented from OpalConnection.

void H323Connection::AnsweringCall | ( | AnswerCallResponse | response | ) | `[virtual]`

Indicate the result of answering an incoming call. This should only be called if the OnAnswerCall() callback function has returned a AnswerCallPending or AnswerCallDeferred response.

Note sending further AnswerCallPending responses via this function will have the result of an Alerting PDU being sent to the remote endpoint. In this way multiple Alerting PDUs may be sent.

Sending a AnswerCallDeferred response would have no effect.

Parameters:

  response | Answer response to incoming call

Reimplemented from OpalConnection.

virtual CallEndReason H323Connection::SendSignalSetup | ( | const PString & | alias,
|  | const H323TransportAddress & | address |
| ) |  |  | `[virtual]`

Send first PDU in signalling channel. This function does the signalling handshaking for establishing a connection to a remote endpoint. The transport (TCP/IP) for the signalling channel is assumed to be already created. This function will then do the SetRemoteAddress() and Connect() calls o establish the transport.

Returns the error code for the call failure reason or NumCallEndReasons if the call was successful to that point in the protocol.

Parameters:

  alias | Name of remote party
  address | Address of destination

virtual PBoolean H323Connection::OnSendSignalSetup | ( | H323SignalPDU & | setupPDU | ) | `[virtual]`

Adjust setup PDU being sent on initialisation of signal channel. This function is called from the SendSignalSetup() function before it sends the Setup PDU. It gives an opportunity for an application to alter the request before transmission to the other endpoint.

The default behaviour simply returns PTrue. Note that this is usually overridden by the transport dependent descendent class, eg the H323ConnectionTCP descendent fills in the destCallSignalAddress field with the TCP/IP data. Therefore if you override this in your application make sure you call the ancestor function.

Parameters:

  setupPDU | Setup PDU to send

virtual PBoolean H323Connection::OnSendCallProceeding | ( | H323SignalPDU & | callProceedingPDU | ) | `[virtual]`

Adjust call proceeding PDU being sent. This function is called from the OnReceivedSignalSetup() function before it sends the Call Proceeding PDU. It gives an opportunity for an application to alter the request before transmission to the other endpoint. If this function returns PFalse then the Call Proceeding PDU is not sent at all.

The default behaviour simply returns PTrue.

Parameters:

  callProceedingPDU | Call Proceeding PDU to send

virtual PBoolean H323Connection::OnSendReleaseComplete | ( | H323SignalPDU & | releaseCompletePDU | ) | `[virtual]`

Call back for Release Complete being sent. This allows an application to add things to the release complete before it is sent to the remote endpoint.

Returning PFalse will prevent the release complete from being sent. Note that this would be very unusual as this is called when the connection is being cleaned up. There will be no second chance to send the PDU and it must be sent.

The default behaviour simply returns PTrue.

Parameters:

  releaseCompletePDU | Release Complete PDU to send

virtual PBoolean H323Connection::OnAlerting | ( | const H323SignalPDU & | alertingPDU,
|  | const PString & | user |
| ) |  |  | `[virtual]`

Call back for remote party being alerted. This function is called from the SendSignalSetup() function after it receives the optional Alerting PDU from the remote endpoint. That is when the remote "phone" is "ringing".

If PFalse is returned the connection is aborted and a Release Complete PDU is sent.

The default behaviour calls the endpoint function of the same name.

Parameters:

  alertingPDU | Received Alerting PDU
  user | Username of remote endpoint

virtual PBoolean H323Connection::OnInsufficientDigits | ( |  | ) | `[virtual]`

This function is called when insufficient digits have been entered. This supports overlapped dialling so that a call can begin when it is not known how many more digits are to be entered in a phone number.

It is expected that the application will override this function. It should be noted that the application should not block in the function but only indicate to whatever other thread is gathering digits that more are required and that thread should call SendMoreDigits().

If PFalse is returned the connection is aborted and a Release Complete PDU is sent.

The default behaviour simply returns PFalse.

virtual void H323Connection::SendMoreDigits | ( | const PString & | digits | ) | `[virtual]`

This function is called when sufficient digits have been entered. This supports overlapped dialling so that a call can begin when it is not known how many more digits are to be entered in a phone number.

The digits parameter is appended to the existing remoteNumber member variable and the call is retried.

If PFalse is returned the connection is aborted and a Release Complete PDU is sent.

The default behaviour simply returns PTrue.

Parameters:

  digits | Extra digits

virtual PBoolean H323Connection::OnOutgoingCall | ( | const H323SignalPDU & | connectPDU | ) | `[virtual]`

This function is called from the SendSignalSetup() function after it receives the Connect PDU from the remote endpoint, but before it attempts to open the control channel.

If PFalse is returned the connection is aborted and a Release Complete PDU is sent.

The default behaviour calls H323EndPoint::OnOutgoingCall

Parameters:

  connectPDU | Received Connect PDU

virtual PBoolean H323Connection::SendFastStartAcknowledge | ( | H225_ArrayOf_PASN_OctetString & | array | ) | `[virtual]`

Send an the acknowldege of a fast start. This function is called when the fast start channels provided to this connection by the original SETUP PDU have been selected and opened and need to be sent back to the remote endpoint.

If PFalse is returned then no fast start has been acknowledged, possibly due to no common codec in fast start request.

The default behaviour uses OnSelectLogicalChannels() to find a pair of channels and adds then to the provided PDU.

Parameters:

  array | Array of H245_OpenLogicalChannel

virtual PBoolean H323Connection::HandleFastStartAcknowledge | ( | const H225_ArrayOf_PASN_OctetString & | array | ) | `[virtual]`

Handle the acknowldege of a fast start. This function is called from one of a number of functions after it receives a PDU from the remote endpoint that has a fastStart field. It is in response to a request for a fast strart from the local endpoint.

If PFalse is returned the connection is aborted and a Release Complete PDU is sent.

The default behaviour parses the provided array and starts the channels acknowledged in it.

Parameters:

  array | Array of H245_OpenLogicalChannel

virtual PBoolean H323Connection::CreateOutgoingControlChannel | ( | const H225_TransportAddress & | h245Address | ) | `[virtual]`

Start a separate H245 channel. This function is called from one of a number of functions after it receives a PDU from the remote endpoint that has a h245Address field.

If PFalse is returned the connection is aborted and a Release Complete PDU is sent.

The default behaviour checks to see if it is a known transport and creates a corresponding H323Transport decendent for the control channel.

Parameters:

  h245Address | H245 address

virtual PBoolean H323Connection::CreateIncomingControlChannel | ( | H225_TransportAddress & | h245Address | ) | `[virtual]`

Start a separate control channel. This function is called from one of a number of functions when it needs to listen for an incoming H.245 connection.

If PFalse is returned the connection is aborted and a Release Complete PDU is sent.

The default behaviour checks to see if it is a known transport and creates a corresponding OpalTransport decendent for the control channel.

Parameters:

  h245Address | PDU transport address to set

virtual PBoolean H323Connection::WriteControlPDU | ( | const H323ControlPDU & | pdu | ) | `[virtual]`

Write a PDU to the control channel. If there is no control channel open then this will tunnel the PDU into the signalling channel.

virtual PBoolean H323Connection::StartControlNegotiations | ( |  | ) | `[virtual]`

Start control channel negotiations.

virtual void H323Connection::HandleControlChannel | ( |  | ) | `[virtual]`

Handle reading data on the control channel.

virtual PBoolean H323Connection::HandleControlData | ( | PPER_Stream & | strm | ) | `[virtual]`

Handle incoming data on the control channel. This decodes the data stream into a PDU and calls HandleControlPDU().

If PFalse is returned the connection is aborted. The default behaviour returns PTrue.

virtual PBoolean H323Connection::HandleControlPDU | ( | const H323ControlPDU & | pdu | ) | `[virtual]`

Handle incoming PDU's on the control channel. Dispatches them to the various virtuals off this class.

If PFalse is returned the connection is aborted. The default behaviour returns PTrue.

virtual PBoolean H323Connection::OnUnknownControlPDU | ( | const H323ControlPDU & | pdu | ) | `[virtual]`

This function is called from the HandleControlPDU() function for unhandled PDU types.

If PFalse is returned the connection is aborted and a Release Complete PDU is sent. The default behaviour returns PTrue.

The default behaviour send a FunctioNotUnderstood indication back to the sender, and returns PTrue to continue operation.

Parameters:

  pdu | Received PDU

virtual PBoolean H323Connection::OnH245Request | ( | const H323ControlPDU & | pdu | ) | `[virtual]`

Handle incoming request PDU's on the control channel. Dispatches them to the various virtuals off this class.

Parameters:

  pdu | Received PDU

virtual PBoolean H323Connection::OnH245Response | ( | const H323ControlPDU & | pdu | ) | `[virtual]`

Handle incoming response PDU's on the control channel. Dispatches them to the various virtuals off this class.

Parameters:

  pdu | Received PDU

virtual PBoolean H323Connection::OnH245Command | ( | const H323ControlPDU & | pdu | ) | `[virtual]`

Handle incoming command PDU's on the control channel. Dispatches them to the various virtuals off this class.

Parameters:

  pdu | Received PDU

virtual PBoolean H323Connection::OnH245Indication | ( | const H323ControlPDU & | pdu | ) | `[virtual]`

Handle incoming indication PDU's on the control channel. Dispatches them to the various virtuals off this class.

Parameters:

  pdu | Received PDU

virtual PBoolean H323Connection::OnH245_SendTerminalCapabilitySet | ( | const H245_SendTerminalCapabilitySet & | pdu | ) | `[virtual]`

Handle H245 command to send terminal capability set.

Parameters:

  pdu | Received PDU

virtual PBoolean H323Connection::OnH245_FlowControlCommand | ( | const H245_FlowControlCommand & | pdu | ) | `[virtual]`

Handle H245 command to control flow control. This function calls OnLogicalChannelFlowControl() with the channel and bit rate restriction.

Parameters:

  pdu | Received PDU

virtual PBoolean H323Connection::OnH245_MiscellaneousCommand | ( | const H245_MiscellaneousCommand & | pdu | ) | `[virtual]`

Handle H245 miscellaneous command. This function passes the miscellaneous command on to the channel defined by the pdu.

Parameters:

  pdu | Received PDU

virtual PBoolean H323Connection::OnH245_MiscellaneousIndication | ( | const H245_MiscellaneousIndication & | pdu | ) | `[virtual]`

Handle H245 miscellaneous indication. This function passes the miscellaneous indication on to the channel defined by the pdu.

Parameters:

  pdu | Received PDU

virtual PBoolean H323Connection::OnH245_JitterIndication | ( | const H245_JitterIndication & | pdu | ) | `[virtual]`

Handle H245 indication of received jitter. This function calls OnLogicalChannelJitter() with the channel and estimated jitter.

Parameters:

  pdu | Received PDU

virtual PBoolean H323Connection::OnControlProtocolError | ( | ControlProtocolErrors | errorSource,
|  | const void * | errorData = `NULL` |
| ) |  |  | `[virtual]`

This function is called from the HandleControlPDU() function or any of its sub-functions for protocol errors, eg unhandled PDU types.

The errorData field may be a string or PDU or some other data depending on the value of the errorSource parameter. These are: e_UnhandledPDU &H323ControlPDU e_MasterSlaveDetermination const char *

If PFalse is returned the connection is aborted. The default behaviour returns PTrue.

Parameters:

  errorSource | Source of the proptoerror
  errorData | Data associated with error

virtual void H323Connection::OnSendCapabilitySet | ( | H245_TerminalCapabilitySet & | pdu | ) | `[virtual]`

This function is called from the HandleControlPDU() function when it is about to send the Capabilities Set to the remote endpoint. This gives the application an oppurtunity to alter the PDU to be sent.

The default behaviour will make "adjustments" for compatibility with some broken remote endpoints.

Parameters:

  pdu | PDU to send

virtual PBoolean H323Connection::OnReceivedCapabilitySet | ( | const H323Capabilities & | remoteCaps,
|  | const H245_MultiplexCapability * | muxCap,
|  | H245_TerminalCapabilitySetReject & | reject |
| ) |  |  | `[virtual]`

This function is called when the remote endpoint sends its capability set. This gives the application an opportunity to determine what codecs are available and if it supports any of the combinations of codecs.

Note any codec types that are the remote system supports that are not in the codecs list member variable for the endpoint are ignored and not included in the remoteCodecs list.

The default behaviour assigns the table and set to member variables and returns PTrue if the remoteCodecs list is not empty.

Parameters:

  remoteCaps | Capability combinations remote supports
  muxCap | Transport capability, if present
  reject | Rejection PDU (if return PFalse)

virtual bool H323Connection::SendCapabilitySet | ( | PBoolean | empty | ) | `[virtual]`

Send a new capability set.

Parameters:

  empty | Send an empty set.

virtual bool H323Connection::IsSendingCapabilitySet | ( |  | ) | `[virtual]`

check if TCS procedure in progress states.

virtual void H323Connection::OnSetLocalCapabilities | ( |  | ) | `[virtual]`

Call back to set the local capabilities. This is called just before the capabilties are required when a call is begun. It is called when a SETUP PDU is received or when one is about to be sent, so that the capabilities may be adjusted for correct fast start operation.

The default behaviour adds all media formats.

PBoolean H323Connection::IsH245Master | ( |  | ) | const

Return if this H245 connection is a master or slave

void H323Connection::StartRoundTripDelay | ( |  | ) |

Start the round trip delay calculation over the control channel.

PTimeInterval H323Connection::GetRoundTripDelay | ( |  | ) | const

Get the round trip delay over the control channel.

virtual void H323Connection::OnSelectLogicalChannels | ( |  | ) | `[virtual]`

Call back to select logical channels to start.

This function must be defined by the descendent class. It is used to select the logical channels to be opened between the two endpoints. There are three ways in which this may be called: when a "fast start" has been initiated by the local endpoint (via SendSignalSetup() function), when a "fast start" has been requested from the remote endpoint (via the OnReceivedSignalSetup() function) or when the H245 capability set (and master/slave) negotiations have completed (via the OnControlChannelOpen() function.

The function would typically examine several member variable to decide which mode it is being called in and what to do. If fastStartState is FastStartDisabled then non-fast start semantics should be used. The H245 capabilities in the remoteCapabilities members should be examined, and appropriate transmit channels started using OpenLogicalChannel().

If fastStartState is FastStartInitiate, then the local endpoint has initiated a call and is asking the application if fast start semantics are to be used. If so it is expected that the function call OpenLogicalChannel() for all the channels that it wishes to be able to be use. A subset (possibly none!) of these would actually be started when the remote endpoint replies.

If fastStartState is FastStartResponse, then this indicates the remote endpoint is attempting a fast start. The fastStartChannels member contains a list of possible channels from the remote that the local endpoint is to select which to accept. For each accepted channel it simply necessary to call the Start() function on that channel eg fastStartChannels[0].Start();

The default behaviour selects the first codec of each session number that is available. This is according to the order of the capabilities in the remoteCapabilities, the local capability table or of the fastStartChannels list respectively for each of the above scenarios.

virtual void H323Connection::SelectDefaultLogicalChannel | ( | const OpalMediaType & | mediaType,
|  | unsigned | sessionID |
| ) |  |  | `[virtual]`

Select default logical channel for normal start.

Parameters:

  mediaType | media type of channel
  sessionID | Session ID to find default logical channel.

virtual void H323Connection::SelectFastStartChannels | ( | unsigned | sessionID,
|  | PBoolean | transmitter,
|  | PBoolean | receiver |
| ) |  |  | `[virtual]`

Select default logical channel for fast start. Internal function, not for normal use.

Parameters:

  sessionID | Session ID to find default logical channel.
  transmitter | Whether to open transmitters
  receiver | Whether to open receivers

virtual void H323Connection::StartFastStartChannel | ( | unsigned | sessionID,
|  | H323Channel::Directions | direction |
| ) |  |  | `[virtual]`

Start a logical channel for fast start. Internal function, not for normal use.

Parameters:

  sessionID | Session ID to find logical channel.
  direction | Direction of channel to start

virtual PBoolean H323Connection::OpenLogicalChannel | ( | const H323Capability & | capability,
|  | unsigned | sessionID,
|  | H323Channel::Directions | dir |
| ) |  |  | `[virtual]`

Open a new logical channel. This function will open a channel between the endpoints for the specified capability.

If this function is called while there is not yet a conenction established, eg from the OnFastStartLogicalChannels() function, then a "trial" receiver/transmitter channel is created. This channel is not started until the remote enpoint has confirmed that they are to start. Any channels not confirmed are deleted.

If this function is called later in the call sequence, eg from OnSelectLogicalChannels(), then it may only establish a transmit channel, ie fromRemote must be PFalse.

Parameters:

  capability | Capability to open channel with
  sessionID | Session for the channel
  dir | Direction of channel

virtual void H323Connection::SendFlowControlCommand | ( | unsigned | channelNumber,
|  | unsigned | newBitRate |
| ) |  |  | `[virtual]`

virtual PBoolean H323Connection::OnOpenLogicalChannel | ( | const H245_OpenLogicalChannel & | openPDU,
|  | H245_OpenLogicalChannelAck & | ackPDU,
|  | unsigned & | errorCode |
| ) |  |  | `[virtual]`

This function is called when the remote endpoint want's to open a new channel.

If the return value is PFalse then the open is rejected using the errorCode as the cause, this would be a value from the enum H245_OpenLogicalChannelReject_cause::Choices.

The default behaviour simply returns PTrue.

Parameters:

  openPDU | Received PDU for the channel open
  ackPDU | PDU to send for acknowledgement
  errorCode | Error to return if refused

virtual PBoolean H323Connection::OnConflictingLogicalChannel | ( | H323Channel & | channel | ) | `[virtual]`

Callback for when a logical channel conflict has occurred. This is called when the remote endpoint, which is a master, rejects our transmitter channel due to a resource conflict. Typically an inability to do asymmetric codecs. The local (slave) endpoint must then try and open a new transmitter channel using the same codec as the receiver that is being opened.

Parameters:

  channel | Channel that conflicted

virtual H323Channel* H323Connection::CreateLogicalChannel | ( | const H245_OpenLogicalChannel & | open,
|  | PBoolean | startingFast,
|  | unsigned & | errorCode |
| ) |  |  | `[virtual]`

Create a new logical channel object. This is in response to a request from the remote endpoint to open a logical channel.

Parameters:

  open | Parameters for opening channel
  startingFast | Flag for fast/slow starting.
  errorCode | Reason for create failure

virtual H323Channel* H323Connection::CreateRealTimeLogicalChannel | ( | const H323Capability & | capability,
|  | H323Channel::Directions | dir,
|  | unsigned | sessionID,
|  | const H245_H2250LogicalChannelParameters * | param,
|  | RTP_QOS * | rtpqos = `NULL` |
| ) |  |  | `[virtual]`

Create a new real time logical channel object. This creates a logical channel for handling RTP data. It is primarily used to allow an application to redirect the RTP media streams to other hosts to the local one. In that case it would create an instance of the H323_ExternalRTPChannel class with the appropriate address. eg:

H323Channel * MyConnection::CreateRealTimeLogicalChannel( const H323Capability & capability, H323Channel::Directions dir, unsigned sessionID, const H245_H2250LogicalChannelParameters * param) { return new H323_ExternalRTPChannel(*this, capability, dir, sessionID, externalIpAddress, externalPort); }

An application would typically also override the OnStartLogicalChannel() function to obtain from the H323_ExternalRTPChannel instance the address of the remote endpoints media server RTP addresses to complete the setting up of the external RTP stack. eg:

PBoolean OnStartLogicalChannel(H323Channel & channel) { H323_ExternalRTPChannel & external = (H323_ExternalRTPChannel &)channel; external.GetRemoteAddress(remoteIpAddress, remotePort); }

Note that the port in the above example is always the data port, the control port is assumed to be data+1.

The default behaviour assures there is an RTP session for the session ID, and if not creates one, then creates a H323_RTPChannel which will do RTP media to the local host.

Parameters:

  capability | Capability creating channel
  dir | Direction of channel
  sessionID | Session ID for RTP channel
  param | Parameters for channel
  rtpqos | QoS for RTP

virtual PBoolean H323Connection::OnCreateLogicalChannel | ( | const H323Capability & | capability,
|  | H323Channel::Directions | dir,
|  | unsigned & | errorCode |
| ) |  |  | `[virtual]`

This function is called when the remote endpoint want's to create a new channel.

If the return value is PFalse then the open is rejected using the errorCode as the cause, this would be a value from the enum H245_OpenLogicalChannelReject_cause::Choices.

The default behaviour checks the capability set for if this capability is allowed to be opened with other channels that may already be open.

Parameters:

  capability | Capability for the channel open
  dir | Direction of channel
  errorCode | Error to return if refused

virtual PBoolean H323Connection::OnStartLogicalChannel | ( | H323Channel & | channel | ) | `[virtual]`

Call back function when a logical channel thread begins.

The default behaviour does nothing and returns PTrue.

Parameters:

  channel | Channel that has been started.

virtual void H323Connection::CloseLogicalChannel | ( | unsigned | number,
|  | PBoolean | fromRemote |
| ) |  |  | `[virtual]`

Close a logical channel.

Parameters:

  number | Channel number to close.
  fromRemote | Indicates close request of remote channel

virtual void H323Connection::CloseLogicalChannelNumber | ( | const H323ChannelNumber & | number | ) | `[virtual]`

Close a logical channel by number.

Parameters:

  number | Channel number to close.

virtual void H323Connection::CloseAllLogicalChannels | ( | PBoolean | fromRemote | ) | `[virtual]`

Close a logical channel.

Parameters:

  fromRemote | Indicates close request of remote channel

virtual void H323Connection::OnClosedLogicalChannel | ( | const H323Channel & | channel | ) | `[virtual]`

This function is called when the remote endpoint has closed down a logical channel.

The default behaviour does nothing.

Parameters:

  channel | Channel that was closed

virtual PBoolean H323Connection::OnClosingLogicalChannel | ( | H323Channel & | channel | ) | `[virtual]`

This function is called when the remote endpoint request the close of a logical channel.

The application may get an opportunity to refuse to close the channel by returning PFalse from this function.

The default behaviour returns PTrue.

Parameters:

  channel | Channel that is to be closed

virtual void H323Connection::OnLogicalChannelFlowControl | ( | H323Channel * | channel,
|  | long | bitRateRestriction |
| ) |  |  | `[virtual]`

This function is called when the remote endpoint wishes to limit the bit rate being sent on a channel.

If channel is NULL, then the bit rate limit applies to all channels.

The default behaviour does nothing if channel is NULL, otherwise calls H323Channel::OnFlowControl() on the specific channel.

Parameters:

  channel | Channel that is to be limited
  bitRateRestriction | Limit for channel

virtual void H323Connection::OnLogicalChannelJitter | ( | H323Channel * | channel,
|  | DWORD | jitter,
|  | int | skippedFrameCount,
|  | int | additionalBuffer |
| ) |  |  | `[virtual]`

This function is called when the remote endpoint indicates the level of jitter estimated by the receiver.

If channel is NULL, then the jitter applies to all channels.

The default behaviour does nothing if channel is NULL, otherwise calls H323Channel::OnJitter() on the specific channel.

Parameters:

  channel | Channel that is to be limited
  jitter | Estimated received jitter in microseconds
  skippedFrameCount | Frames skipped by decodec
  additionalBuffer | Additional size of video decoder buffer

H323Channel* H323Connection::GetLogicalChannel | ( | unsigned | number,
|  | PBoolean | fromRemote |
| ) |  |  | const

Get a logical channel. Locates the specified channel number and returns a pointer to it.

Parameters:

  number | Channel number to get.
  fromRemote | Indicates get a remote channel

H323Channel* H323Connection::FindChannel | ( | unsigned | sessionId,
|  | PBoolean | fromRemote |
| ) |  |  | const

Find a logical channel. Locates a channel give a RTP session ID. Each session would usually have two logical channels associated with it, so the fromRemote flag bay be used to distinguish which channel to return.

Parameters:

  sessionId | Session ID to search for.
  fromRemote | Indicates the direction of RTP data.

virtual PBoolean H323Connection::SetBandwidthAvailable | ( | unsigned | newBandwidth,
|  | PBoolean | force = `PFalse` |
| ) |  |  | `[virtual]`

Set the available bandwidth in 100's of bits/sec. Note if the force parameter is PTrue this function will close down active logical channels to meet the new bandwidth requirement.

Parameters:

  newBandwidth | New bandwidth limit
  force | Force bandwidth limit

Reimplemented from OpalConnection.

virtual unsigned H323Connection::GetBandwidthUsed | ( |  | ) | const`[virtual]`

Get the bandwidth currently used. This totals the open channels and returns the total bandwidth used in 100's of bits/sec

Reimplemented from OpalConnection.

virtual SendUserInputModes H323Connection::GetRealSendUserInputMode | ( |  | ) | const`[virtual]`

Get the real user input indication transmission mode. This will return the user input mode that will actually be used for transmissions. It will be the value of GetSendUserInputMode() provided the remote endpoint is capable of that mode.

Reimplemented from OpalConnection.

virtual PBoolean H323Connection::SendUserInputString | ( | const PString & | value | ) | `[virtual]`

Send a user input indication to the remote endpoint. This is for sending arbitrary strings as user indications.

The user indication is sent according to the sendUserInputMode member variable. If SendUserInputAsString then this uses an H.245 "string" UserInputIndication pdu sending the entire string in one go. If SendUserInputAsTone then a separate H.245 "signal" UserInputIndication pdu is sent for each character. If SendUserInputAsInlineRFC2833 then the indication is inserted into the outgoing audio stream as an RFC2833 RTP data pdu.

SendUserInputAsSeparateRFC2833 is not yet supported.

Parameters:

  value | String value of indication

Reimplemented from OpalConnection.

virtual PBoolean H323Connection::SendUserInputTone | ( | char | tone,
|  | unsigned | duration = `0` |
| ) |  |  | `[virtual]`

Send a user input indication to the remote endpoint. This sends DTMF emulation user input. If something more sophisticated than the simple tones that can be sent using the SendUserInput() function.

A duration of zero indicates that no duration is to be indicated. A non-zero logical channel indicates that the tone is to be syncronised with the logical channel at the rtpTimestamp value specified.

The tone parameter must be one of "0123456789#*ABCD!" where '!' indicates a hook flash. If tone is a ' ' character then a signalUpdate PDU is sent that updates the last tone indication sent. See the H.245 specifcation for more details on this.

The user indication is sent according to the sendUserInputMode member variable. If SendUserInputAsString then this uses an H.245 "string" UserInputIndication pdu sending the entire string in one go. If SendUserInputAsTone then a separate H.245 "signal" UserInputIndication pdu is sent for each character. If SendUserInputAsInlineRFC2833 then the indication is inserted into the outgoing audio stream as an RFC2833 RTP data pdu.

SendUserInputAsSeparateRFC2833 is not yet supported.

Parameters:

  tone | DTMF tone code
  duration | Duration of tone in milliseconds

Reimplemented from OpalRTPConnection.

virtual PBoolean H323Connection::SendUserInputIndicationQ931 | ( | const PString & | value | ) | `[virtual]`

Send a user input indication to the remote endpoint. This is for sending arbitrary strings as user indications.

This always uses a Q.931 Keypad Information Element in a Information pdu sending the entire string in one go.

Parameters:

  value | String value of indication

virtual PBoolean H323Connection::SendUserInputIndicationString | ( | const PString & | value | ) | `[virtual]`

Send a user input indication to the remote endpoint. This is for sending arbitrary strings as user indications.

This always uses an H.245 "string" UserInputIndication pdu sending the entire string in one go.

Parameters:

  value | String value of indication

virtual PBoolean H323Connection::SendUserInputIndicationTone | ( | char | tone,
|  | unsigned | duration = `0`,
|  | unsigned | logicalChannel = `0`,
|  | unsigned | rtpTimestamp = `0` |
| ) |  |  | `[virtual]`

Send a user input indication to the remote endpoint. This sends DTMF emulation user input.This uses an H.245 "signal" UserInputIndication pdu.

Parameters:

  tone | DTMF tone code
  duration | Duration of tone in milliseconds
  logicalChannel | Logical channel number for RTP sync.
  rtpTimestamp | RTP timestamp in logical channel sync.

virtual PBoolean H323Connection::SendUserInputIndication | ( | const H245_UserInputIndication & | pdu | ) | `[virtual]`

Send a user input indication to the remote endpoint. The two forms are for basic user input of a simple string using the SendUserInput() function or a full DTMF emulation user input using the SendUserInputTone() function.

An application could do more sophisticated usage by filling in the H245_UserInputIndication structure directly ans using this function.

Parameters:

  pdu | Full user indication PDU

virtual void H323Connection::OnUserInputIndication | ( | const H245_UserInputIndication & | pdu | ) | `[virtual]`

Call back for remote enpoint has sent user input. The default behaviour calls OnUserInputString() if the PDU is of the alphanumeric type, or OnUserInputTone() if of a tone type.

Parameters:

  pdu | Full user indication PDU

virtual H323_RTP_Session* H323Connection::GetSessionCallbacks | ( | unsigned | sessionID | ) | const`[virtual]`

Get an H323 RTP session for the specified ID. If there is no session of the specified ID, NULL is returned.

virtual RTP_Session* H323Connection::UseSession | ( | const OpalTransport & | transport,
|  | unsigned | sessionID,
|  | const OpalMediaType & | mediatype,
|  | RTP_QOS * | rtpqos = `NULL` |
| ) |  |  | `[virtual]`

Use an RTP session for the specified ID and for the given direction. If there is no session of the specified ID, a new one is created using the information provided in the tranport parameter. If the system does not support the specified transport, NULL is returned.

If this function is used, then the ReleaseSession() function MUST be called or the session is never deleted for the lifetime of the H323 connection.

Parameters:

  mediatype | media type

Reimplemented from OpalRTPConnection.

virtual void H323Connection::ReleaseSession | ( | unsigned | sessionID | ) | `[virtual]`

Release the session. If the session ID is not being used any more any clients via the UseSession() function, then the session is deleted.

virtual void H323Connection::OnRTPStatistics | ( | const RTP_Session & | session | ) | const`[virtual]`

Callback from the RTP session for statistics monitoring. This is called every so many packets on the transmitter and receiver threads of the RTP session indicating that the statistics have been updated.

The default behaviour calls H323EndPoint::OnRTPStatistics().

Parameters:

  session | Session with statistics

virtual PString H323Connection::GetSessionCodecNames | ( | unsigned | sessionID | ) | const`[virtual]`

Get the names of the codecs in use for the RTP session. If there is no session of the specified ID, an empty string is returned.

virtual PBoolean H323Connection::RequestModeChange | ( | const PString & | newModes | ) | `[virtual]`

Make a request to mode change to remote. This asks the remote system to stop it transmitters and start sending one of the combinations specifed.

The modes are separated in the string by
characters, and all of the channels (capabilities) are strings separated by characters. Thus a very simple mode change would be "T.38" which requests that the remote start sending T.38 data and nothing else. A more complicated example would be "G.723\tH.261\nG.729\tH.261\nG.728" which indicates that the remote should either start sending G.723 and H.261, G.729 and H.261 or just G.728 on its own.

Returns PFalse if a mode change is currently in progress, only one mode change may be done at a time.

Parameters:

  newModes | New modes to select

virtual PBoolean H323Connection::RequestModeChange | ( | const H245_ArrayOf_ModeDescription & | newModes | ) | `[virtual]`

Make a request to mode change to remote. This asks the remote system to stop it transmitters and start sending one of the combinations specifed.

Returns PFalse if a mode change is currently in progress, only one mode change may be done at a time.

Parameters:

  newModes | New modes to select

virtual PBoolean H323Connection::OnRequestModeChange | ( | const H245_RequestMode & | pdu,
|  | H245_RequestModeAck & | ack,
|  | H245_RequestModeReject & | reject,
|  | PINDEX & | selectedMode |
| ) |  |  | `[virtual]`

Received request for mode change from remote.

Parameters:

  pdu | Received PDU
  ack | Ack PDU to send
  reject | Reject PDU to send
  selectedMode | Which mode was selected

virtual void H323Connection::OnModeChanged | ( | const H245_ModeDescription & | newMode | ) | `[virtual]`

Completed request for mode change from remote. This is a call back that accurs after the ack has been sent to the remote as indicated by the OnRequestModeChange() return result. This function is intended to actually implement the mode change after it had been accepted.

virtual void H323Connection::OnAcceptModeChange | ( | const H245_RequestModeAck & | pdu | ) | `[virtual]`

Received acceptance of last mode change request. This callback indicates that the RequestModeChange() was accepted by the remote endpoint.

Parameters:

  pdu | Received PDU

virtual void H323Connection::OnRefusedModeChange | ( | const H245_RequestModeReject * | pdu | ) | `[virtual]`

Received reject of last mode change request. This callback indicates that the RequestModeChange() was accepted by the remote endpoint.

Parameters:

  pdu | Received PDU, if NULL is a timeout

virtual PBoolean H323Connection::RequestModeChangeT38 | ( | const char * | capabilityNames = `"T.38\nT38FaxUDP"` | ) | `[virtual]`

Request a mode change to T.38 data.

virtual PBoolean H323Connection::GetAdmissionRequestAuthentication | ( | const H225_AdmissionRequest & | arq,
|  | H235Authenticators & | authenticators |
| ) |  |  | `[virtual]`

Get separate H.235 authentication for the connection. This allows an individual ARQ to override the authentical credentials used in H.235 based RAS for this particular connection.

A return value of PFalse indicates to use the default credentials of the endpoint, while PTrue indicates that new credentials are to be used.

The default behavour does nothing and returns PFalse.

Parameters:

  arq | ARQ being constructed
  authenticators | New authenticators for ARQ

H323EndPoint& H323Connection::GetEndPoint | ( |  | ) | const`[inline]`

Get the owner endpoint for this connection.

Reimplemented from OpalConnection.

PBoolean H323Connection::HadAnsweredCall | ( |  | ) | const`[inline]`

Get the call direction for this connection.

PBoolean H323Connection::IsGatekeeperRouted | ( |  | ) | const`[inline]`

Determined if connection is gatekeeper routed.

unsigned H323Connection::GetDistinctiveRing | ( |  | ) | const`[inline]`

Get the distinctive ring code for incoming call. This returns an integer from 0 to 7 that may indicate to an application that different ring cadences are to be used.

void H323Connection::SetDistinctiveRing | ( | unsigned | pattern | ) | `[inline]`

Set the distinctive ring code for outgoing call. This sets the integer from 0 to 7 that will be used in the outgoing Setup PDU. Note this must be called either immediately after construction or during the OnSendSignalSetup() callback function so the member variable is set befor ethe PDU is sent.

const PString& H323Connection::GetCallToken | ( |  | ) | const`[inline]`

Get the internal OpenH323 call token for this connection. Deprecated, only used for backward compatibility.

unsigned H323Connection::GetCallReference | ( |  | ) | const`[inline]`

Get the call reference for this connection.

const OpalGloballyUniqueID& H323Connection::GetCallIdentifier | ( |  | ) | const`[inline]`

Get the call identifier for this connection. preserved for backwards compatibility with OpenH323 only

const OpalGloballyUniqueID& H323Connection::GetConferenceIdentifier | ( |  | ) | const`[inline]`

Get the conference identifier for this connection.

void H323Connection::SetLocalPartyName | ( | const PString & | name | ) | `[virtual]`

Set the local name/alias from information in the PDU.

Reimplemented from OpalConnection.

const PStringList& H323Connection::GetLocalAliasNames | ( |  | ) | const`[inline]`

Get the list of all alias names this connection is using.

virtual void H323Connection::SetRemotePartyInfo | ( | const H323SignalPDU & | pdu | ) | `[virtual]`

Set the name/alias of remote end from information in the PDU.

Parameters:

  pdu | PDU from which to extract party info.

void H323Connection::SetRemoteApplication | ( | const H225_EndpointType & | pdu | ) |

Set the name/alias of remote end from information in the PDU.

Parameters:

  pdu | PDU from which to extract application info.

PString H323Connection::GetRemotePartyURL | ( |  | ) | const`[virtual]`

Get the remote party address. This will return the "best guess" at an address to use in a to call the user again later.

Reimplemented from OpalConnection.

const H323Capabilities& H323Connection::GetLocalCapabilities | ( |  | ) | const`[inline]`

Get the remotes capability table for this connection.

const H323Capabilities& H323Connection::GetRemoteCapabilities | ( |  | ) | const`[inline]`

Get the remotes capability table for this connection.

unsigned H323Connection::GetRemoteMaxAudioDelayJitter | ( |  | ) | const`[inline]`

Get the maximum audio jitter delay.

const H323Transport* H323Connection::GetSignallingChannel | ( |  | ) | const`[inline]`

Get the signalling channel being used.

unsigned H323Connection::GetSignallingVersion | ( |  | ) | const`[inline]`

Get the signalling channel protocol version number.

const H323Transport& H323Connection::GetControlChannel | ( |  | ) | const

Get the control channel being used (may return signalling channel).

OpalTransport& H323Connection::GetTransport | ( |  | ) | const`[virtual]`

Get the control channel being used (may return signalling channel).

Reimplemented from OpalConnection.

unsigned H323Connection::GetControlVersion | ( |  | ) | const`[inline]`

Get the control channel protocol version number.

unsigned H323Connection::GetUUIEsRequested | ( |  | ) | const`[inline]`

Get the UUIE PDU monitor bit mask.

void H323Connection::SetUUIEsRequested | ( | unsigned | mask | ) | `[inline]`

Set the UUIE PDU monitor bit mask.

const PString H323Connection::GetGkAccessTokenOID | ( |  | ) | const`[inline]`

Get the iNow Gatekeeper Access Token OID.

void H323Connection::SetGkAccessTokenOID | ( | const PString & | oid | ) | `[inline]`

Set the iNow Gatekeeper Access Token OID.

const PBYTEArray& H323Connection::GetGkAccessTokenData | ( |  | ) | const`[inline]`

Get the iNow Gatekeeper Access Token data.

void H323Connection::SetDestExtraCallInfo | ( | const PString & | info | ) | `[inline]`

Set the Destionation Extra Call Info memeber.

void H323Connection::SetRemotCallWaiting | ( | const unsigned | value | ) | `[inline]`

Set the remote call waiting flag

int H323Connection::GetRemoteCallWaiting | ( |  | ) | const`[inline]`

How many caller's are waiting on the remote endpoint? -1 - None 0 - Just this connection n - n plus this connection

void H323Connection::SetEnforcedDurationLimit | ( | unsigned | seconds | ) |

Set the enforced duration limit for the call. This starts a timer that will automatically shut down the call when it expires.

Parameters:

  seconds | max duration of call in seconds

virtual PBoolean H323Connection::OnSendFeatureSet | ( | unsigned | ,
|  | H225_FeatureSet & |  |
| ) |  |  | const`[virtual]`

virtual void H323Connection::OnReceiveFeatureSet | ( | unsigned | ,
|  | const H225_FeatureSet & |  |
| ) |  |  | const`[virtual]`

virtual PBoolean H323Connection::OnOpenIncomingMediaChannels | ( |  | ) | `[virtual]`

Open the media channels associated with an incoming call

This function is provided to allow an OpalConnection descendant to delay the opening of the media channels associated with an incoming call. By default, this function is called as soon as possible after an incoming connection request has been received (i.e. an INVITE or SETUP) and and do all of the work associated with handling SDP or fastStart eyc

By overriding this function, the media channel open is deferred, which gives the other connections in the call a chance to do something before the media channels are started. This allows for features beyond those provided by the OnAnswer interface

Overriding this function is ok, provided the application ensures that this method in this class is called.

Reimplemented from OpalConnection.

virtual void H323Connection::OnMediaCommand | ( | OpalMediaCommand & | note,
|  | INT | extra |
| ) |  |  | `[virtual]`

Reimplemented from OpalRTPConnection.

virtual void H323Connection::InternalEstablishedConnectionCheck | ( |  | ) | `[protected, virtual]`

Internal function to check if call established. This checks all the criteria for establishing a call an initiating the starting of media channels, if they have not already been started via the fast start algorithm.

PBoolean H323Connection::InternalEndSessionCheck | ( | PPER_Stream & | strm | ) | `[protected]`

void H323Connection::SetRemoteVersions | ( | const H225_ProtocolIdentifier & | id | ) | `[protected]`

void H323Connection::MonitorCallStatus | ( |  | ) | `[protected]`

H323Connection::PDECLARE_NOTIFIER | ( | PThread | ,
|  | H323Connection | ,
|  | StartOutgoing |  |
| ) |  |  | `[protected]`

H323Connection::PDECLARE_NOTIFIER | ( | PThread | ,
|  | H323Connection | ,
|  | NewOutgoingControlChannel |  |
| ) |  |  | `[protected]`

H323Connection::PDECLARE_NOTIFIER | ( | PThread | ,
|  | H323Connection | ,
|  | NewIncomingControlChannel |  |
| ) |  |  | `[protected]`

## Member Data Documentation

H323EndPoint& H323Connection::endpoint `[protected]`

Reimplemented from OpalConnection.

int H323Connection::remoteCallWaiting `[protected]`

PBoolean H323Connection::gatekeeperRouted `[protected]`

unsigned H323Connection::distinctiveRing `[protected]`

unsigned H323Connection::callReference `[protected]`

OpalGloballyUniqueID H323Connection::conferenceIdentifier `[protected]`

PString H323Connection::localDestinationAddress `[protected]`

PStringList H323Connection::localAliasNames `[protected]`

H323Capabilities H323Connection::localCapabilities `[protected]`

PString H323Connection::destExtraCallInfo `[protected]`

H323Capabilities H323Connection::remoteCapabilities `[protected]`

unsigned H323Connection::remoteMaxAudioDelayJitter `[protected]`

PTimer H323Connection::roundTripDelayTimer `[protected]`

WORD H323Connection::maxAudioDelayJitter `[protected]`

unsigned H323Connection::uuiesRequested `[protected]`

PString H323Connection::gkAccessTokenOID `[protected]`

PBYTEArray H323Connection::gkAccessTokenData `[protected]`

PBoolean H323Connection::addAccessTokenToSetup `[protected]`

PBoolean H323Connection::alertDone `[protected]`

H323Transport* H323Connection::signallingChannel `[protected]`

H323Transport* H323Connection::controlChannel `[protected]`

OpalListener* H323Connection::controlListener `[protected]`

PBoolean H323Connection::h245Tunneling `[protected]`

H323SignalPDU* H323Connection::h245TunnelRxPDU `[protected]`

H323SignalPDU* H323Connection::h245TunnelTxPDU `[protected]`

H323SignalPDU* H323Connection::setupPDU `[protected]`

H323SignalPDU* H323Connection::alertingPDU `[protected]`

H323SignalPDU* H323Connection::connectPDU `[protected]`

H323SignalPDU* H323Connection::progressPDU `[protected]`

enum H323Connection::ConnectionStates H323Connection::connectionState `[protected]`

unsigned H323Connection::h225version `[protected]`

unsigned H323Connection::h245version `[protected]`

PBoolean H323Connection::h245versionSet `[protected]`

PBoolean H323Connection::doH245inSETUP `[protected]`

PBoolean H323Connection::lastPDUWasH245inSETUP `[protected]`

PBoolean H323Connection::mustSendDRQ `[protected]`

PBoolean H323Connection::mediaWaitForConnect `[protected]`

PBoolean H323Connection::transmitterSidePaused `[protected]`

bool H323Connection::remoteTransmitPaused `[protected]`

PBoolean H323Connection::earlyStart `[protected]`

PString H323Connection::t38ModeChangeCapabilities `[protected]`

PSyncPoint H323Connection::digitsWaitFlag `[protected]`

PBoolean H323Connection::endSessionNeeded `[protected]`

PSyncPoint H323Connection::endSessionReceived `[protected]`

PTimer H323Connection::enforcedDurationLimit `[protected]`

PChannel* H323Connection::holdMediaChannel `[protected]`

PBoolean H323Connection::isConsultationTransfer `[protected]`

PBoolean H323Connection::isCallIntrusion `[protected]`

Call Intrusion flag and parameters

unsigned H323Connection::callIntrusionProtectionLevel `[protected]`

FastStartStates H323Connection::fastStartState `[protected]`

H323LogicalChannelList H323Connection::fastStartChannels `[protected]`

OpalMediaStreamPtr H323Connection::fastStartMediaStream `[protected]`

H245NegMasterSlaveDetermination* H323Connection::masterSlaveDeterminationProcedure `[protected]`

H245NegTerminalCapabilitySet* H323Connection::capabilityExchangeProcedure `[protected]`

H245NegLogicalChannels* H323Connection::logicalChannels `[protected]`

H245NegRequestMode* H323Connection::requestModeProcedure `[protected]`

H245NegRoundTripDelay* H323Connection::roundTripDelayProcedure `[protected]`

The documentation for this class was generated from the following file:

- h323con.h